if (isObject(PlayerItemHeld_MinigameHud))
{
	if (isObject(PlayerItemHeld_MinigameHud.GAME_OVERLAY))
		PlayerItemHeld_MinigameHud.GAME_OVERLAY.delete();
	
	PlayerItemHeld_MinigameHud.delete();
}
if (isObject(HeldPlayerItemMinigameActionMap))
	HeldPlayerItemMinigameActionMap.delete();

new GuiControl(PlayerItemHeldMinigameHudContainer)
{
	profile = "GuiContentProfile";
	horizSizing = "center";
	vertSizing = "center";
	position = "253 485";
	extent = "1024 768";
	minExtent = "8 2";
	visible = "1";
	
new GuiSwatchCtrl(PlayerItemHeld_MinigameHud)
{
	profile = "GuiDefaultProfile";
	horizSizing = "center";
	vertSizing = "center";
	position = "253 485";
	extent = "486 62";
	minExtent = "8 2";
	visible = "1";
	color = "0 0 0 0";

	new GuiSwatchCtrl()
	{
		profile = "GuiDefaultProfile";
		horizSizing = "width";
		vertSizing = "height";
		position = "0 0";
		extent = "486 41";
		minExtent = "8 2";
		visible = "1";
		color = "0 0 0 0";

		new GuiMLTextCtrl(PIH_MG_Text)
		{
			profile = "GuiHeldPlayerItemTextProfile";
			horizSizing = "center";
			vertSizing = "center";
			position = "0 5";
			extent = "484 32";
			minExtent = "8 2";
			visible = "1";
			lineSpacing = "2";
			allowColorChars = "0";
			maxChars = "-1";
			text = "THIS VALUE IS SET ELSEWHERE";
			maxBitmapHeight = "-1";
			selectable = "1";
		};
	};
	new GuiSwatchCtrl(PIH_MG_BottomPanel)
	{
		profile = "GuiDefaultProfile";
		horizSizing = "width";
		vertSizing = "top";
		position = "0 41";
		extent = "486 21";
		minExtent = "8 2";
		visible = "1";
		color = "0 0 0 0";

		new GuiSwatchCtrl(PIH_MG_ProgressBarBG)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "width";
			vertSizing = "top";
			position = "1 1";
			extent = "484 19";
			minExtent = "8 2";
			visible = "1";
			color = "0 0 0 255";
	
			new GuiSwatchCtrl()
			{
				profile = "GuiDefaultProfile";
				horizSizing = "width";
				vertSizing = "height";
				position = "1 1";
				extent = "482 17";
				minExtent = "8 2";
				visible = "1";
				color = "255 255 255 255";
	
				new GuiSwatchCtrl(PIH_MG_ProgressBar)
				{
					profile = "GuiDefaultProfile";
					horizSizing = "width";
					vertSizing = "height";
					position = "1 1";
					extent = "480 15";
					minExtent = "0 0";
					visible = "1";
					color = "127 0 255 255";
				};
			};
		};
		
		new GuiBitmapCtrl(PIH_MG_BrokenProgressBar)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "center";
			vertSizing = "center";
			position = "1 0";
			extent = "486 21";
			minExtent = "8 2";
			visible = "0";
			bitmap = "Add-Ons/Item_Player/img/StruggleBar_Broken";
		};
	};
};
};

function PlayerItemHeld_MinigameHud::onWake(%this)
{
	%DestX = (getWord(PlayGui.getExtent(), 0) / 2) - (getWord(%this.getExtent(), 0) / 2);
	%DestY = (getWord(PlayGui.getExtent(), 1) / 2) - getWord(%this.getExtent(), 1);
	%DestW = getWord(%this.getExtent(), 0);
	%DestH = getWord(%this.getExtent(), 1);
	%this.resize(%DestX, %DestY, %DestW, %DestH);
	
	if (isEventPending(%this.thinkSchedule))
		return;
	
	if (!isObject(%this.GAME_OVERLAY))
	{
		%this.GAME_OVERLAY = new GuiSwatchCtrl()
		{
			profile = "GuiControlProfile";
			horizSizing = "width";
			vertSizing = "height";
			position = "0 0";
			extent = PlayGui.getExtent();
			minExtent = "8 2";
			visible = "1";
			color = "0 0 0 0";
		};
	}
	
	// Hide the real progress bar & show the broken one
	PIH_MG_ProgressBarBG.setVisible(true);
	PIH_MG_BrokenProgressBar.setVisible(false);
	PIH_MG_Text.setText("<just:center>Spam <spush><color:ff0000>CLICK<spop> to free yourself!");
	
	PlayGui.add(%this.GAME_OVERLAY);
	PlayGui.pushToBack(%this.GAME_OVERLAY);
	PlayGui.pushToBack(%this);
	
	%this.progress      = 50;
	%this.maxProgress   = 100;
	%this.degradeRate   = 4;			//<< The amount to lower the progress by, per second
	%this.degradeTime   = 1000;			//<< The amount of time, in milliseconds, that it takes to fully apply the degrade multiplier to the degrade rate if the mouse is not clicked.
	%this.degradeMult   = 2;			//<< The maximum amount to degrade the progress by.
	%this.powerRate     = 6;			//<< The amount to raise the progress by per click
	%this.cooldownTime  = 100;			//<< The amount of time, in milliseconds, to ignore subsequent mouse clicks
	%this.bonusTime     = 350;			//<< The maximum amount of time the player has to get a bonus multiplier applied when clicking.
	%this.bonusMult     = 0.15;			//<< The maximum bonus multiplier to apply to the power bar.
	%this.clickBuffer   = "";
	%this.lostAct       = 0;
	%this.lostTime      = 0;
	%this.hasLost       = false;
	%this.lastClickTime = getSimTime();
	%this.lastTickTime  = getSimTime();
	
	// Create a new action map
	if (!isObject(%this.actMap))
		%this.actMap = new ActionMap(HeldPlayerItemMinigameActionMap);
	
	// Setup the action map.
	%this.actMap.bindCmd("mouse", "button0", "PlayerItemHeld_MinigameHud.onStruggle();", "");
	%this.actMap.push();
	
	// Now, THINK.
	%this.onThink();
}

function PlayerItemHeld_MinigameHud::onSleep(%this)
{
	// Stop the think schedule; We're not on screen anymore.
	if (isEventPending(%this.thinkSchedule))
		cancel(%this.thinkSchedule);
	
	// Pop the action map; We're not reacting to it anymore.
	if (isObject(%this.actMap))
		%this.actMap.pop();
	
	// Restore the bottom panel's X position.
	if (%this.hasLost && this.lostAct >= 1)
		PIH_MG_BottomPanel.resize(%this.lostBarX, getWord(PIH_MG_BottomPanel.getPosition(), 1), getWord(PIH_MG_BottomPanel.getExtent(), 0), getWord(PIH_MG_BottomPanel.getExtent(), 1));
	
	// Remove our overlay as well.
	PlayGui.remove(%this.GAME_OVERLAY);
}

function PlayerItemHeld_MinigameHud::setProgress(%this, %prog, %maxProg)
{
	if (%maxProg == 0)
	{
		error("Trying to set progress bar with max progress amount of 0.");
		return;
	}
	
	%DestX = 1;
	%DestY = 1;
	%DestW = (getWord(PIH_MG_ProgressBar.getGroup().getExtent(), 0) - 2) * mClamp(%prog, 0, %maxProg) / %maxProg;
	%DestH = getWord(PIH_MG_ProgressBar.getGroup().getExtent(), 1) - 2;
	
	PIH_MG_ProgressBar.resize(%DestX, %DestY, %DestW, %DestH);
}

function PlayerItemHeld_MinigameHud::onStruggle(%this)
{
	// Ignore quick clicks
	if ((getSimTime() - %this.lastClickTime) < %this.cooldownTime)
		return;
	
	// Calculate time. Mr Freeman.
	%currentTime        = getSimTime();
	%deltaTime          = %currentTime - %this.lastClickTime;
	%this.lastClickTime = %currentTime;
	%this.clickBuffer   = trim(%this.clickBuffer SPC %deltaTime);
}

function PlayerItemHeld_MinigameHud::onWin(%this)
{
	%this.setShown(false);
	
	// I know you can bypass the entire point of this mini-game by just typing this in yourself. It was just fun to make. - Clay
	commandToServer('PlayerItem_DropMe');
}

function PlayerItemHeld_MinigameHud::onLose(%this)
{
	commandToServer('PlayerItem_LostMinigame');
	%this.hasLost = true;
	%this.lostAct = 0;
	
	// Hide the real progress bar & show the broken one
	PIH_MG_ProgressBarBG.setVisible(false);
	PIH_MG_BrokenProgressBar.setVisible(true);
}

function PlayerItemHeld_MinigameHud::onThink_Lost(%this, %deltaTime)
{
	%bottomPanel = PlayerItemHeld_MinigameHud;
	//%bottomPanel = PIH_MG_BottomPanel;
	
	switch (%this.lostAct)
	{
		case 0:
			// INIT: Shake the progress bar.
			%this.lostTime        = getSimTime();
			%this.lostAct         = 1;
			%this.lostBarX        = getWord(%bottomPanel.getPosition(), 0);
			%this.lostDelayExtra  = 700;
			%this.lostDelay       = 500;
			%this.lostShakeCount  = 12;
			%this.lostShakeTime   = %this.lostDelay / %this.lostShakeCount;
			%this.lostShakeAmount = 32;
			%this.lostWasNegative = true;
			PIH_MG_Text.setText("<just:center><color:ff0000>MINI-GAME LOST!");
			
			%this.GAME_OVERLAY.color = "0 0 0 127";
		
		case 1:
			// Shake the progress bar.
			if (getSimTime() - %this.lostTime >= %this.lostDelay)
			{
				if (getSimTime() - %this.lostTime >= %this.lostDelay + %this.lostDelayExtra)
					%this.lostAct = 2;
				
				%bottomPanel.resize(%this.lostBarX, getWord(%bottomPanel.getPosition(), 1), getWord(%bottomPanel.getExtent(), 0), getWord(%bottomPanel.getExtent(), 1));
				return;
			}
			
			// Determine the lost time delta.
			%lostDelta = getSimTime() - %this.lostTime;
			
			// Determine the amount to shake by
			%isNegative = ((%lostDelta % (%this.lostShakeTime * 2)) <= %this.lostShakeTime);
			%newPosOffX = %this.lostShakeAmount - (%this.lostShakeAmount * mFloor(%lostDelta / %this.lostShakeTime) / %this.lostShakeCount);
			
			// Stop if we have nothing to change this frame
			//if (%this.lostWasNegative == %isNegative)
			//	return;
			
			// Update this for next frame
			%this.lostWasNegative = %isNegative;
			
			// Set the new position.
			%bottomPanel.resize((%isNegative ? %this.lostBarX - %newPosOffX : %this.lostBarX + %newPosOffX), getWord(%bottomPanel.getPosition(), 1), getWord(%bottomPanel.getExtent(), 0), getWord(%bottomPanel.getExtent(), 1));
		case 2:
			// INIT: Throw self off building
			%this.lostTime     = getSimTime();
			%this.lostAct      = 3;
			%this.lostBarY     = getWord(PlayerItemHeld_MinigameHud.getPosition(), 1) * 0x200;
			%this.lostVelocity = -0x10FF;
		
		case 3:
			// Throw self off building
			%this.lostVelocity += 0x100;
			
			// Limit its velocity
			if (%this.lostVelocity > 0x1EFF)
				%this.lostVelocity = 0x1EFF;

			%this.lostBarY += %this.lostVelocity;
			
			%DestX = getWord(PlayerItemHeld_MinigameHud.getPosition(), 0);
			%DestY = %this.lostBarY / 0x200;
			%DestW = getWord(PlayerItemHeld_MinigameHud.getExtent(), 0);
			%DestH = getWord(PlayerItemHeld_MinigameHud.getExtent(), 1);
			PlayerItemHeld_MinigameHud.resize(%DestX, %DestY, %DestW, %DestH);
			
			// Check for act completed condition
			if ((%this.lostBarY / 0x200) >= getWord(PlayGui.getExtent(), 1))
			{
				// It's off the screen.
				%this.lostTime   = getSimTime();
				%this.lostAct    = 4;
				%this.lostDelay  = 1400;
				%this.lostColorA = getWord(%this.GAME_OVERLAY.color, 3);
			}
		
		case 4:
			// Clear screen grayscale
			if (getSimTime() - %this.lostTime >= %this.lostDelay)
			{
				%this.setShown(false);
				return;
			}
			
			%this.GAME_OVERLAY.color = "0 0 0" SPC (%this.lostColorA - (%this.lostColorA * (getSimTime() - %this.lostTime) / %this.lostDelay));
	}
}

function PlayerItemHeld_MinigameHud::onThink(%this)
{
	%currentTime       = getSimTime();
	%deltaTime         = %currentTime - %this.lastTickTime;
	%this.lastTickTime = %currentTime;
	
	// Special thinks
	if (%this.hasLost)
	{
		%this.onThink_Lost(%deltaTime);

		// Schedule our next thinking session
		cancel(%this.thinkSchedule);
		%this.thinkSchedule = %this.schedule(1, onThink);
		return;
	}
	
	// Run through the click buffer
	for (%i = 0; %i < getWordCount(%this.clickBuffer); %i++)
	{
		%clickDeltaTime = getWord(%this.clickBuffer, %i);
		%struggleAmount = %this.powerRate;
		
		// Calculate if we deserved a bonus
		if (%clickDeltaTime < %this.bonusTime)
			%struggleAmount *= 1 + (%this.bonusMult - (%this.bonusMult * %clickDeltaTime / %this.bonusTime));
		
		// Put it into effect.
		%this.progress += %struggleAmount;
		
		// Log it.
		//echo("[" @ %i @ "] Struggle Amount = " @ %struggleAmount @ ", Time = " @ %clickDeltaTime @ ", bringing progress from " @ (%this.progress - %struggleAmount) @ " to " @ %this.progress @ ".");
	}
	
	// Reset the click buffer
	%this.clickBuffer = "";
	
	// Check for win condition
	if (%this.progress >= %this.maxProgress)
	{
		%this.onWin();
		return;
	}
	
	// Degrade the progress
	%clickTimeDelta = (%currentTime - %this.lastClickTime);
	%degradeMult    = (%this.degradeMult * %clickTimeDelta / %this.degradeTime);
	%amountToTake   = (!GuiEditorGui.isAwake() ? ((%this.degradeRate * %degradeMult) * %deltaTime / 1000) : 0);
	
	// Remove it!
	if (%this.progress < %amountToTake)
	{
		// You lose.
		%this.progress = 0;
		%this.onLose();
		
		// Schedule our next thinking session
		cancel(%this.thinkSchedule);
		%this.thinkSchedule = %this.schedule(1, onThink);
		return;
	}
	else
		%this.progress -= %amountToTake;
	
	// Update the progress bar.
	%this.setProgress(%this.progress, %this.maxProgress);
	
	// Schedule our next thinking session
	cancel(%this.thinkSchedule);
	%this.thinkSchedule = %this.schedule(1, onThink);
}

function PlayerItemHeld_MinigameHud::isShown(%this)
{
	return isEventPending(%this.thinkSchedule);
}

function PlayerItemHeld_MinigameHud::setShown(%this, %value)
{
	// ALWAYS stop the think schedule due to the check in ::onWake.
	cancel(%this.thinkSchedule);
	
	// ALWAYS add it back to the container first, to avoid ::onWake not being called.
	if (%this.getGroup().getName() !$= "PlayerItemHeldMinigameHudContainer")
		PlayerItemHeldMinigameHudContainer.add(PlayerItemHeld_MinigameHud);
	
	// Add it to playgui only if we want it there
	if (%value)
		PlayGui.add(PlayerItemHeld_MinigameHud);
}