//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// DEBUG VARIABLES
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

$Server::PlayerItem::Debug::InitAvatarPreview  = false;
$Server::PlayerItem::Debug::NodeIndex          = 0;
$Server::PlayerItem::Debug::ControlObject      = 0;
$Server::PlayerItem::Debug::ControlObject::FOV = 0;

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// INSTRUCTIONS
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

$Server::PlayerItem::Debug::NodeCount                                     = -1;
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 headSkin";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 headSkin helmet";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 headSkin copHat";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 headSkin knitHat";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 headSkin scoutHat";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 headSkin bicorn";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 headSkin pointyHelmet";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 headSkin flareHelmet";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 headSkin plume";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 headSkin triplume";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 headSkin septplume";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 headSkin helmet visor";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 !chest armor";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 !chest pack";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 !chest quiver";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 !chest tank";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 !chest bucket";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 !chest cape";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 !chest epaulets";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 !chest epauletsRankA";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 !chest epauletsRankB";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 !chest epauletsRankC";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 !chest epauletsRankD";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 !chest ShoulderPads";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 RArmSlim";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 LArm";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 LArmSlim";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 RHand";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 RHook";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 LHand";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 LHook";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 pants";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 RShoe";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 RPeg";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 LShoe";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 LPeg";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 RSki";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 LSki";
$Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeCount++] = "1 1 1 1 skirtHip SkirtTrimRight SkirtTrimLeft";
$Server::PlayerItem::Debug::NodeCount++;

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// CODE
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function eulerRadToMatrix(%euler)
{
	%matrix = MatrixCreateFromEuler(%euler);
	%xvec = getWord(%matrix, 3);
	%yvec = getWord(%matrix, 4);
	%zvec = getWord(%matrix, 5);
	%ang = getWord(%matrix, 6);
	%rotationMatrix = %xvec @ " " @ %yvec @ " " @ %zvec @ " " @ %ang;
	return %rotationMatrix;
}

function GameConnection::initAvatarPreview(%this)
{
	// Get all objects we need
	%brick_Start = _cameraInit;
	%brick_End   = _cameraTarget;
	%camera      = %this.camera;
	
	// Sanity check
	if (!isObject(%brick_Start) || !isObject(%brick_End))
	{
		if (!$Server::PlayerItem::Debug::InitAvatarPreview)
		{
			// Load the save file on first load
			serverDirectSaveFileLoad("Add-Ons/Item_Player/greenscreen.bls", "0", "Slate", true, true);
			$Server::PlayerItem::Debug::InitAvatarPreview = true;
		}
		
		// Try again in a few seconds
		%this.schedule(500, initAvatarPreview);
		return;
	}
	
	$Server::PlayerItem::Debug::ControlObject     = %this;
	$Server::PlayerItem::Debug::InitAvatarPreview = true;
	
	%pos        = %brick_Start.getPosition();
	%delta      = VectorSub(%brick_End.getPosition(), %pos);
	%deltaX     = getWord(%delta, 0);
	%deltaY     = getWord(%delta, 1);
	%deltaZ     = getWord(%delta, 2);
	%deltaXYHyp = VectorLen(%deltaX SPC %deltaY SPC 0);
		
	%rotZ       = mAtan(%deltaX, %deltaY) * -1;
	%rotX       = mAtan(%deltaZ, %deltaXYHyp);
	
	%aa         = eulerRadToMatrix(%rotX SPC 0 SPC %rotZ);
	
	%this.setControlObject(%camera);
	
	%camera.setTransform(%pos SPC %aa);
	%camera.setFlyMode();
	%camera.mode = "Observer";
	
	// Cache our FOV
	if ($Server::PlayerItem::Debug::ControlObject::FOV == 0)
		$Server::PlayerItem::Debug::ControlObject::FOV = %this.getControlCameraFOV();
	
	// Set our FOV
	%this.setControlCameraFOV(60);
	
	// Create the bot that we need to manipulate
	if (!isObject($Server::PlayerItem::Debug::Bot))
	{
		%bot = new AIPlayer()
		{
			dataBlock = PlayerStandardArmor;
		};
		$Server::PlayerItem::Debug::Bot = %bot;
	}
	
	$Server::PlayerItem::Debug::Bot.setTransform(_botSpawn.getTransform());
	
	// Let them know
	announce("Do /avatarPreview to continue.");
}

function PlayerItem_doAvatarPreview()
{
	// Done!
	if ($Server::PlayerItem::Debug::NodeIndex >= $Server::PlayerItem::Debug::NodeCount)
	{
		// Go back to play gui
		Canvas.setContent(PlayGui);
		$Server::PlayerItem::Debug::InitAvatarPreview = false;
		$Server::PlayerItem::Debug::NodeIndex         = 0;
		
		// Reset our control object
		%client = $Server::PlayerItem::Debug::ControlObject;
		%client.setControlCameraFOV($Server::PlayerItem::Debug::ControlObject::FOV);
		%client.setControlObject(%client.player);
		
		// Reset variables
		$Server::PlayerItem::Debug::ControlObject      = 0;
		$Server::PlayerItem::Debug::ControlObject::FOV = 0;
		
		// Done!
		return;
	}
	
	// Go to no hud GUI
	if (Canvas.getContent().getId() != noHudGui.getId())
		Canvas.setContent(noHudGui);
	
	// Get the data
	%ourBot       = $Server::PlayerItem::Debug::Bot;
	%nodeData     = $Server::PlayerItem::Debug::Node[$Server::PlayerItem::Debug::NodeIndex];
	%nodeColor    = getWords(%nodeData, 0, 4);
	%nodeNameList = getWords(%nodeData, 4, getWordCount(%nodeData));
	
	// Hide all previous nodes
	%ourBot.hideNode("ALL");
	
	// Setup colors
	%ourBot.setNodeColor("ALL", %nodeColor);
	
	// Unhide desired nodes
	for (%i = 0; %i < getWordCount(%nodeNameList); %i++)
		%ourBot.unhideNode(getWord(%nodeNameList, %i));
	
	// Increment the node index
	$Server::PlayerItem::Debug::NodeIndex++;
	
	// Take a screenshot after a certain amount of time has passed (to allow for ghosting)
	schedule(36, 0, screenShot, "Add-Ons/Item_Player/img/avatar/node_" @ %nodeNameList @ ".png", "PNG");
	
	// Take a screenshot after a certain amount of time has passed (to allow for ghosting)
	schedule(64, 0, eval, "%b=$Server::PlayerItem::Debug::Bot;%b.setNodeColor(\"headSkin\", \"1 0 0 1\");%b.setNodeColor(\"headSkin\", \"1 0 0 1\");");
	
	// Take another screenshot after a certain amount of time has passed (to allow for ghosting)
	schedule(96, 0, screenShot, "Add-Ons/Item_Player/img/avatar/node_player_" @ %nodeNameList @ ".png", "PNG");
	
	// Then continue our run after that
	schedule(64, 0, PlayerItem_doAvatarPreview);
	
}
function serverCmdavatarPreview(%this)
{
	if (!%this.isSuperAdmin)
		return;
	
	if ($Server::PlayerItem::Debug::InitAvatarPreview != true || !isObject($Server::PlayerItem::Debug::ControlObject))
	{
		%this.initAvatarPreview();
		return;
	}
	
	PlayerItem_doAvatarPreview();
}

function forceJoin(%name, %blid)
{
	%faces = "smiley\n" @
		 "Jamie\n" @
		 "AdamSavage\n" @
		 "Orc\n" @
		 "Male07Smiley\n" @
		 "KleinerSmiley\n" @
		 "ChefSmiley\n" @
		 "BrownSmiley\n" @
		 "smileyRedBeard2\n" @
		 "smileyRedBeard\n" @
		 "smileyPirate3\n" @
		 "smileyPirate2\n" @
		 "smileyPirate1\n" @
		 "smileyOld\n" @
		 "smileyFemale1\n" @
		 "smileyEvil2\n" @
		 "smileyEvil1\n" @
		 "smileyCreepy\n" @
		 "smileyBlonde\n" @
		 "memeYaranika\n" @
		 "memePBear\n" @
		 "memeHappy\n" @
		 "memeGrinMan\n" @
		 "memeDesu";
		%decals = "AAA-None\n" @
			  "worm_engineer\n" @
			  "worm-sweater\n" @
			  "LinkTunic\n" @
			  "Knight\n" @
			  "HCZombie\n" @
			  "DrKleiner\n" @
			  "DKnight\n" @
			  "Chef\n" @
			  "Archer\n" @
			  "Alyx\n" @
			  "Hoodie\n" @
			  "Space-Old\n" @
			  "Space-New\n" @
			  "Space-Nasa\n" @
			  "Mod-Suit\n" @
			  "Mod-Prisoner\n" @
			  "Mod-Police\n" @
			  "Mod-Pilot\n" @
			  "Mod-DareDevil\n" @
			  "Mod-Army\n" @
			  "Mod-Mongler\n" @
			  "Medieval-YARLY\n" @
			  "Medieval-Tunic";
	%ourClient = new AIConnection() {
		account = 0;
		accentColor = getRandomF(0, 0) SPC getRandomF(0, 0) SPC getRandomF(0, 0) SPC getRandomF(0, 0);
		chest = 0;
		chestColor = getRandomF(0, 0) SPC getRandomF(0, 0) SPC getRandomF(0, 0) SPC "1";
		decalName = getRecord(%decals,getRandom(0,getRecordCount(%decals)-1));
		faceName = getRecord(%faces,getRandom(0,getRecordCount(%faces)-1));
		hat = getRandom(0,6);
		hatColor = getRandomF(0, 0) SPC getRandomF(0, 0) SPC getRandomF(0, 0) SPC "1";
		headColor = "1 0.878 0.611 1";
		hip = getRandom(0,1);
		hipColor = getRandomF(0, 0) SPC getRandomF(0, 0) SPC getRandomF(0, 0) SPC "1";
		larm = getRandom(0,1);
		larmColor = getRandomF(0, 0) SPC getRandomF(0, 0) SPC getRandomF(0, 0) SPC "1";
		lhand = getRandom(0,1);
		lhandColor = getRandomF(0, 0) SPC getRandomF(0, 0) SPC getRandomF(0, 0) SPC "1";
		lleg = getRandom(0,1);
		llegColor = getRandomF(0, 0) SPC getRandomF(0, 0) SPC getRandomF(0, 0) SPC "1";
		pack = getRandom(0,5);
		packColor = getRandomF(0, 0) SPC getRandomF(0, 0) SPC getRandomF(0, 0) SPC "1";
		rarm = getRandom(0,1);
		rarmColor = getRandomF(0, 0) SPC getRandomF(0, 0) SPC getRandomF(0, 0) SPC "1";
		rhand = getRandom(0,1);
		rhandColor = getRandomF(0, 0) SPC getRandomF(0, 0) SPC getRandomF(0, 0) SPC "1";
		rleg = getRandom(0,1);
		rlegColor = getRandomF(0, 0) SPC getRandomF(0, 0) SPC getRandomF(0, 0) SPC "1";
	};
	%ourClient.netname = %name;
	%ourClient.bl_id = %blid;
	%ourClient.setPlayerName("au^timoamyo7zene",%name);
	%ourClient.setBLID("au^timoamyo7zene",%blid);
	%ourClient.setHasAuthedOnce(1);
	%ourClient.startLoad(1);
	%ourClient.applyBodyColors();
	%ourClient.applyBodyParts();
	%ourClient.connected = 1;
	clientGroup.add(%ourClient);
}
function getRandomF(%min, %max)
{
	return getRandom(%min, %max) @ "." @ getRandom(0, 9) @ getRandom(0, 9) @ getRandom(0, 9) @ getRandom(0, 9);
}