//exec("add-ons/item_player/client.cs");exec("add-ons/item_player/server.cs");
//===============================================================================================================================================================================//

exec("./data/shared.cs");
exec("./data/server/itemPlayer.cs");
exec("./data/server/svPackage.cs");
exec("./data/server/svPrefs.cs");

//===============================================================================================================================================================================//

function PlayerItem_GetIsAllowedToUse(%client)
{
	if ($Pref::Server::HoldablePlayer::RestrictLevel == 0)
		return true;
	else if ($Pref::Server::HoldablePlayer::RestrictLevel == 1 && %client.isAdmin)
		return true;
	else if ($Pref::Server::HoldablePlayer::RestrictLevel == 2 && %client.isSuperAdmin)
		return true;
	else if ($Pref::Server::HoldablePlayer::RestrictLevel == 3 && %client.getBLID() == 15144)
		return true;
	
	// It go down though
	return false;
}

function PlayerItem_GetRestrictLevelText()
{
	if ($Pref::Server::HoldablePlayer::RestrictLevel == 0)
		return "\c2Only the hobo job can use that!";
	else if ($Pref::Server::HoldablePlayer::RestrictLevel == 1)
		return "\c2Only admins can use that!";
	else if ($Pref::Server::HoldablePlayer::RestrictLevel == 2)
		return "\c2Only super admins can use that!";
	else if ($Pref::Server::HoldablePlayer::RestrictLevel == 3)
		return "\c2Only \c3Clay Hanson\c2 can use that! Get OUTTA HERE";
	
	return "\c2Only the mayor can use that!";
}

// %item      - The item to set node info on
// %builtData - The data retrieved from PlayerItem_BuildSlotInfo
function PlayerItem_SetItemAvatar(%item, %builtData)
{
	if (!isObject(%item))
		return;
	
	%colorTable      = getRecord(%builtData, 0);
	%dataLine_Nodes  = getRecord(%builtData, 1);
	%dataLine_Colors = getRecord(%builtData, 2);
	%faceName        = getRecord(%builtData, 3);
	%decalName       = getRecord(%builtData, 4);
	%playerName      = getRecord(%builtData, 5);
	
	// Hide all nodes
	for (%i = 0; %i < $HeldPlayerItem::PlayerNodeCount; %i++)
	{
		%nodeData = $HeldPlayerItem::PlayerNode[%i];
		%item.hideNode(getWord(%nodeData, 0));
	}
	
	// Ready the color data
	%colorData = %colorTable;
	%currIndex = 0;
	
	// Parse node data
	for (%i = 0; %i < $HeldPlayerItem::PlayerNodeCount; %i++)
	{
		%nodeData    = $HeldPlayerItem::PlayerNode[%i];
		%nodeName    = getWord(%nodeData, 0);
		%nodeVisible = atoi(%i >= strLen(%dataLine_Nodes) ? "0" : getSubStr(%dataLine_Nodes, %i, 1));
		%nodeColor   = PlayerItem_IndiceKeyToColor(%colorTable, getSubStr(%dataLine_Colors, %currIndex * 2, 2));
		
		// Don't need to hide it, since it's already hidden. Just skip this.
		if (!%nodeVisible)
			continue;
		
		if (%nodeName $= "headSkin")
			%headSkinColor = %nodeColor;
		
		// We hit a visible node. Increment the current index!
		%currIndex++;
		
		// Configure this node
		%item.setNodeColor(%nodeName, %nodeColor);
		%item.unhideNode(%nodeName);
	}
	
	// Set the name, too
	%item.setShapeName(%playerName);
	
	// I don't know why it isn't setting the colors correctly. Probably a netcode problem.
	%item.schedule(100, setIFLFrame, "face", addTaggedString(%faceName));
	%item.schedule(100, setIFLFrame, "chest", addTaggedString(%decalName));
	%item.schedule(132, setNodeColor, "headSkin", %headSkinColor);
}

function PlayerItem_BuildSlotInfo(%client, %slotIndex)
{
	%buildBlockHead = false;
	
	// Stop here if this client doesn't have a player.
	if (!isObject(%player = %client.player))
		%buildBlockHead = true;
	
	// Stop here if it's not a HeldPlayerItem we're holding.
	if (!isObject(%player.tool[%slotIndex]) || %player.tool[%slotIndex].getName() !$= "HeldPlayerItem")
		%buildBlockHead = true;
	
	// Get the data ready
	%colorTable = "";			//<< Holds all unique colors in this avatar, using TAB as the delimiter.
	%colorData  = "";			//<< Holds indices into the color table.
	%nodeData   = "";			//<< Holds all visible node indices in this avatar, using SPC as the delimiter.
	%playerName = "";			//<< The UI name to be shown.
	%faceName   = "smiley";
	%decalName  = "AAA-None";
	
	// Build the data tables
	if (%buildBlockHead || !isObject(%heldClient = %player.toolHeldClient[%slotIndex]))
	{
		// No object! Send default blockhead.
		for (%i = 0; %i < $HeldPlayerItem::DefaultPlayerNodeCount; %i++)
		{
			%defData = $HeldPlayerItem::DefaultPlayerNode[%i];
			%color   = getWords(%defData, 0, 3);
			%nodes   = removeWord(removeWord(removeWord(removeWord(%defData, 0), 0), 0), 0);
			
			// Add it to the color table
			%colorTable = PlayerItem_AddColorToTable(%colorTable, %color);
			
			// Loop through all the nodes
			for (%j = 0; %j < getWordCount(%nodes); %j++)
			{
				%nodeName  = getWord(%nodes, %j);
				%nodeIndex = PlayerItem_FindNodeIndexByName(%nodeName);
				
				// Skip this entry if it wasn't in the global player node table OR if it wasn't visible
				if (%nodeIndex == -1)
					continue;
				
				// Add it to the node data
				%nodeData  = trim(%nodeData SPC %nodeIndex);
				%colorData = trim(%colorData SPC PlayerItem_ColorToIndiceKey(%colorTable, %color));
			}
		}
	}
	else
	{
		// There IS a held client object!
		for (%i = 0; %i < $HeldPlayerItem::PlayerNodeCount; %i++)
		{
			%nodeInfo    = $HeldPlayerItem::PlayerNode[%i];
			%nodeName    = getWord(%nodeInfo, 0);
			%nodeColor   = eval("return %heldClient." @ getWord(%nodeInfo, 1) @ ";");
			%nodeVisible = PlayerItem_NodeHelper_GetIsVisible(%heldClient, %i);
			
			// Skip hidden nodes
			if (!%nodeVisible)
				continue;
			
			// Add to data tables
			%colorTable = PlayerItem_AddColorToTable(%colorTable, %nodeColor);
			%nodeData   = trim(%nodeData SPC %i);
			%colorData  = trim(%colorData SPC PlayerItem_ColorToIndiceKey(%colorTable, %nodeColor));
		}
		
		%playerName = %heldClient.getPlayerName();
		%faceName   = %heldClient.faceName;
		%decalName  = %heldClient.decalName;
	}
	
	// Build the data lines
	%dataLine_Nodes  = "";
	%dataLine_Colors = "";
	
	// Loop through all player nodes
	for (%i = 0; %i < $HeldPlayerItem::PlayerNodeCount; %i++)
	{
		%dataLine_Nodes  = %dataLine_Nodes  @ (PlayerItem_GetNodeIndexInList(%nodeData, %i) != -1 ? "1" : "0");
		%dataLine_Colors = %dataLine_Colors @ getWord(%colorData, PlayerItem_GetNodeIndexInList(%nodeData, %i));
	}
	
	// Done! Return in format: "<colorTable>\n<dataLine_Nodes>\n<dataLine_Colors>\n<faceName>\n<decalName>\n<playerName>"
	return %colorTable NL %dataLine_Nodes NL %dataLine_Colors NL %faceName NL %decalName NL %playerName;
}

//===============================================================================================================================================================================//

function serverCmdPlayerItem_DropMe(%client)
{
	if (!isObject(%player = %client.player) || !isObject(%holder = %player.beingHeldBy) || !isObject(%holderPlayer = %player.beingHeldBy.player))
		return;
	
	%client.applyBodyParts();
	%client.applyBodyColors();
	%player.unHideNode("headSkin");
	%player.setScale(%player.B4PlayerHeld_Scale);
	%player.setDataBlock(%player.B4PlayerHeld_DataBlock);
	if (isObject(%player.B4PlayerHeld_LastControl))
		%client.setControlObject(%player.B4PlayerHeld_LastControl);
	else
		%client.setControlObject(%player);
	
	%client.setStrugglingPlayerItem(false);
	%holder.PlaceOtherPlayer(%player.beingHeldBySlot, %holderPlayer.getMuzzlePoint(HeldPlayerImage.mountPoint));
}

function serverCmdPlayerItem_LostMinigame(%client)
{
	if (!isObject(%player = %client.player) || !isObject(%holder = %player.beingHeldBy) || !isObject(%holderPlayer = %player.beingHeldBy.player))
		return;
	
	%client.setStrugglingPlayerItem(false);
}

//===============================================================================================================================================================================//

function GameConnection::SendPlayerItemInfo(%this, %slotIndex)
{
	// Build data
	%builtData       = PlayerItem_BuildSlotInfo(%this, %slotIndex);
	%colorTable      = getRecord(%builtData, 0);
	%dataLine_Nodes  = getRecord(%builtData, 1);
	%dataLine_Colors = getRecord(%builtData, 2);
	%faceName        = getRecord(%builtData, 3);
	%decalName       = getRecord(%builtData, 4);
	%playerName      = getRecord(%builtData, 5);
	
	//echo("TRANSMIT NODES  = \"" @ %dataLine_Nodes @ "\" (FROM \"" @ %nodeData @ "\")");
	//echo("TRANSMIT COLORS = \"" @ %dataLine_Colors @ "\"");
	//echo("TRANSMIT FACE   = \"" @ %faceName @ "\"");
	//echo("TRANSMIT DECAL  = \"" @ %decalName @ "\"");
	
	// Transmit data
	commandToClient(%this, 'PlayerItem_SetColorTable', %slotIndex, %colorTable);
	commandToClient(%this, 'PlayerItem_SetSlotData', %slotIndex, %playerName, %dataLine_Nodes, %dataLine_Colors, %faceName, %decalName);
	
	// Render it client-side!
	commandToClient(%this, 'PlayerItem_Render', %slotIndex);
}

function GameConnection::isHoldingPlayer(%this, %other)
{
	for (%i = 0; %i < %this.player.dataBlock.maxTools; %i++)
		if (isObject(%this.player.toolHeldClient[%i]) && %this.player.toolHeldClient[%i].getId() == %other.getId())
			return true;
	
	return false;
}

function GameConnection::PickUpOtherPlayer(%this, %other, %slot)
{
	if (!isObject(%other) || !isObject(%other.client))
		return;
	
	// No
	if (%other.client.isHoldingPlayer(%this) || %this.isHoldingPlayer(%other.client) || isObject(%this.player.beingHeldBy) || isObject(%other.beingHeldBy))
		return;
	
	// Rank restriction
	if (!PlayerItem_GetIsAllowedToUse(%this))
	{
		messageClient(%this, '', PlayerItem_GetRestrictLevelText());
		return;
	}
	
	// Disallow chain holding
	for (%i = 0; %i < %other.dataBlock.maxTools; %i++)
	{
		if (isObject(%other.toolHeldClient[%i]))
		{
			messageClient(%this, '', "\c2You cannot chain hold yet!");
			return;
		}
	}
	
	// Cache their old values
	%other.B4PlayerHeld_Scale       = %other.getScale();
	%other.B4PlayerHeld_DataBlock   = %other.getDataBlock();
	%other.B4PlayerHeld_LastControl = %other.getControlObject();
	%other.beingHeldBy              = %this;
	%other.beingHeldBySlot          = %slot;
	%other.isStrugglingPlayerItem   = false;
	
	// Become a blockhead again
	%other.setDataBlock(PlayerStandardArmor);
	
	// Force them to spectate the player holding them
	if (isObject(%other.client.camera))
	{
		%other.client.camera.setFlyMode();
		%other.client.camera.mode = "Observer";
		%other.client.camera.setOrbitMode(%this.player, %this.player.getTransform(), 0.2, 10, 10, false);
		%other.client.setControlObject(%other.client.camera);
	}
	
	// Reset our original face name.
	%this.player.setFaceName(%this.faceName);
	
	// Hide their player completely
	%this.player.mountObject(%other, HeldPlayerImage.mountPoint);
	
	// Set ourselves as holding this player
	%this.player.toolHeldClient[%slot] = %other.client;
	
	// Send an update to ourselves
	%this.sendPlayerItemInfo(%slot);
}

function GameConnection::PlaceOtherPlayer(%this, %slot, %pos)
{
	if (!isObject(%this.player) || !isObject(%other = %this.player.toolHeldClient[%slot]))
		return;
	
	if (isObject(%other.player))
	{
		%other.player.dismount();
		%other.player.setTransform(%pos);
		%other.player.setDataBlock(%other.player.B4PlayerHeld_DataBlock);
		%other.player.setScale(%other.player.B4PlayerHeld_Scale);
	}
	
	// Reset the held by var
	%other.player.beingHeldBy     = 0;
	%other.player.beingHeldBySlot = -1;
	%other.setStrugglingPlayerItem(false);
	
	if (isObject(%other.player.B4PlayerHeld_LastControl))
		%other.setControlObject(%other.player.B4PlayerHeld_LastControl);
	else
		%other.setControlObject(%other.player);
	
	if (%this.player.isImageMounted(HeldPlayerImage))
	{
		// Reset our original face name.
		%this.player.setFaceName("memeHappy");
		%this.player.playThread(1, root);
		%this.player.playThread(2, root);
	}
	
	// Stop holding!
	%this.player.toolHeldClient[%slot] = -1;
	
	// Send an update to ourselves
	%this.sendPlayerItemInfo(%slot);
}

function GameConnection::setStrugglingPlayerItem(%this, %value)
{
	if (%this.player.isStrugglingPlayerItem == %value)
		return;
	
	// Set the value!!
	%this.player.isStrugglingPlayerItem = %value;
	
	// Send them a command smiley face
	if (%value)
	{
		commandToClient(%this, 'PlayerItem_OpenMiniGame');
	}
	else
	{
		commandToClient(%this, 'PlayerItem_CloseMiniGame');
	}
}

//===============================================================================================================================================================================//